---
title: Stacking context example 3
slug: Web/CSS/CSS_Positioning/Understanding_z_index/Stacking_context_example_3
tags:
  - Advanced
  - CSS
  - Guide
  - Understanding_CSS_z-index
---
<div>{{cssref}}</div>

<p>« <a href="/en-US/docs/Web/CSS">CSS</a> « <a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index" title="Understanding CSS z-index">Understanding CSS z-index</a></p>

<h2 id="Stacking_context_example_3">Stacking context example 3</h2>

<p>This last example shows problems that arise when mixing several positioned elements in a multi-level HTML hierarchy and when z-indexes are assigned using class selectors.</p>

<p>Let's take as an example a three-level hierarchical menu made from several positioned DIVs. Second-level and third-level DIVs appear when hovering or clicking on their parents. Usually this kind of menu is script-generated either client-side or server-side, so style rules are assigned with a class selector instead of the id selector.</p>

<p>If the three menu levels partially overlap, then managing stacking could become a problem.</p>

<p>{{ EmbedLiveSample('Example_source_code', '320', '330') }}</p>

<p>The first-level menu is only relatively positioned, so no stacking context is created.</p>

<p>The second-level menu is absolutely positioned inside the parent element. In order to put it above all first-level menus, a <code>z-index</code> is used. The problem is that for each second-level menu, a stacking context is created and each third-level menu belongs to the context of its parent.</p>

<p>So a third-level menu will be stacked under the following second-level menus, because all second-level menus share the same <code>z-index</code> value and the default stacking rules apply.</p>

<p>To better understand the situation, here is the stacking context hierarchy:</p>

<ul>
 <li>root stacking context
  <ul>
   <li>LEVEL #1
    <ul>
     <li>LEVEL #2 (z-index: 1)
      <ul>
       <li>LEVEL #3</li>
       <li>...</li>
       <li>LEVEL #3</li>
      </ul>
     </li>
     <li>LEVEL #2 (z-index: 1)</li>
     <li>...</li>
     <li>LEVEL #2 (z-index: 1)</li>
    </ul>
   </li>
   <li>LEVEL #1</li>
   <li>...</li>
   <li>LEVEL #1</li>
  </ul>
 </li>
</ul>

<p>This problem can be avoided by removing overlapping between different level menus, or by using individual (and different) <code>z-index</code> values assigned through the id selector instead of class selector, or by flattening the HTML hierarchy.</p>

<div class="note"><strong>Note:</strong> In the source code you will see that second-level and third level menus are made of several DIVs contained in an absolutely positioned container. This is useful to group and position all of them at once.</div>

<h2 id="Example_source_code">Example source code</h2>

<pre class="brush: html notranslate">&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"&gt;
&lt;html&gt;
&lt;head&gt;&lt;style type="text/css"&gt;

div { font: 12px Arial; }

span.bold { font-weight: bold; }

div.lev1 {
   width: 250px;
   height: 70px;
   position: relative;
   border: 2px outset #669966;
   background-color: #ccffcc;
   padding-left: 5px;
}

#container1 {
   z-index: 1;
   position: absolute;
   top: 30px;
   left: 75px;
}

div.lev2 {
   opacity: 0.9;
   width: 200px;
   height: 60px;
   position: relative;
   border: 2px outset #990000;
   background-color: #ffdddd;
   padding-left: 5px;
}

#container2 {
   z-index: 1;
   position: absolute;
   top: 20px;
   left: 110px;
}

div.lev3 {
   z-index: 10;
   width: 100px;
   position: relative;
   border: 2px outset #000099;
   background-color: #ddddff;
   padding-left: 5px;
}

&lt;/style&gt;&lt;/head&gt;

&lt;body&gt;

&lt;br /&gt;

&lt;div class="lev1"&gt;
&lt;span class="bold"&gt;LEVEL #1&lt;/span&gt;

   &lt;div id="container1"&gt;

      &lt;div class="lev2"&gt;
      &lt;br /&gt;&lt;span class="bold"&gt;LEVEL #2&lt;/span&gt;
      &lt;br /&gt;z-index: 1;

         &lt;div id="container2"&gt;

            &lt;div class="lev3"&gt;&lt;span class="bold"&gt;LEVEL #3&lt;/span&gt;&lt;/div&gt;
            &lt;div class="lev3"&gt;&lt;span class="bold"&gt;LEVEL #3&lt;/span&gt;&lt;/div&gt;
            &lt;div class="lev3"&gt;&lt;span class="bold"&gt;LEVEL #3&lt;/span&gt;&lt;/div&gt;
            &lt;div class="lev3"&gt;&lt;span class="bold"&gt;LEVEL #3&lt;/span&gt;&lt;/div&gt;
            &lt;div class="lev3"&gt;&lt;span class="bold"&gt;LEVEL #3&lt;/span&gt;&lt;/div&gt;
            &lt;div class="lev3"&gt;&lt;span class="bold"&gt;LEVEL #3&lt;/span&gt;&lt;/div&gt;
            &lt;div class="lev3"&gt;&lt;span class="bold"&gt;LEVEL #3&lt;/span&gt;&lt;/div&gt;
            &lt;div class="lev3"&gt;&lt;span class="bold"&gt;LEVEL #3&lt;/span&gt;&lt;/div&gt;
            &lt;div class="lev3"&gt;&lt;span class="bold"&gt;LEVEL #3&lt;/span&gt;&lt;/div&gt;
            &lt;div class="lev3"&gt;&lt;span class="bold"&gt;LEVEL #3&lt;/span&gt;&lt;/div&gt;
            &lt;div class="lev3"&gt;&lt;span class="bold"&gt;LEVEL #3&lt;/span&gt;&lt;/div&gt;

         &lt;/div&gt;

      &lt;/div&gt;

      &lt;div class="lev2"&gt;
      &lt;br /&gt;&lt;span class="bold"&gt;LEVEL #2&lt;/span&gt;
      &lt;br /&gt;z-index: 1;
      &lt;/div&gt;

   &lt;/div&gt;
&lt;/div&gt;

&lt;div class="lev1"&gt;
&lt;span class="bold"&gt;LEVEL #1&lt;/span&gt;
&lt;/div&gt;

&lt;div class="lev1"&gt;
&lt;span class="bold"&gt;LEVEL #1&lt;/span&gt;
&lt;/div&gt;

&lt;div class="lev1"&gt;
&lt;span class="bold"&gt;LEVEL #1&lt;/span&gt;
&lt;/div&gt;

&lt;/body&gt;&lt;/html&gt;
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/Stacking_without_z-index">Stacking without the z-index property</a>: The stacking rules that apply when <code>z-index</code> is not used.</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/Stacking_and_float">Stacking with floated blocks</a>: How floating elements are handled with stacking.</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/Adding_z-index">Using z-index</a>: How to use <code>z-index</code> to change default stacking.</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/The_stacking_context">The stacking context</a>: Notes on the stacking context.</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/Stacking_context_example_1">Stacking context example 1</a>: 2-level HTML hierarchy, <code>z-index</code> on the last level</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/Stacking_context_example_2">Stacking context example 2</a>: 2-level HTML hierarchy, <code>z-index</code> on all levels</li>
</ul>

<div class="originaldocinfo">
<h2 id="Original_Document_Information">Original Document Information</h2>

<ul>
 <li>Author(s): Paolo Lombardi</li>
 <li>This article is the English translation of an article I wrote in Italian for <a class="external" href="http://www.yappy.it">YappY</a>. I grant the right to share all the content under the <a class="external" href="http://creativecommons.org/licenses/by-sa/2.0/">Creative Commons: Attribution-Sharealike license</a>.</li>
 <li>Last Updated Date: July 9, 2005</li>
</ul>
</div>

<p><strong>Note</strong>: the reason the sample image looks wrong - with the second level 2 overlapping the level 3 menus - is because level 2 has opacity, which creates a new stacking context. Basically, this whole sample page is incorrect and misleading.</p>
